

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>Exercises (2)</title>
    
    <link rel="stylesheet" href="_static/default.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    './',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <script type="text/javascript" src="_static/sidebar.js"></script>

        <script src="http://sagecell.sagemath.org/static/jquery.min.js"></script>
        <script src="http://sagecell.sagemath.org/static/embedded_sagecell.js"></script>

        <script>sagecell.makeSagecell({inputLocation: ".sage"});</script>

        <style type="text/css">
                .sagecell .CodeMirror-scroll {
                        overflow-y: hidden;
                        overflow-x: auto;
                }
                .sagecell .CodeMirror {
                        height: auto;
                }
        </style>

    
    <link rel="top" title="Introduction to finite element methods" href="index.html" />
    <link rel="next" title="Bibliography" href="._main_fem023.html" />
    <link rel="prev" title="Systems of differential equations" href="._main_fem021.html" />
 
  
   <style type="text/css">
     div.admonition {
       background-color: whiteSmoke;
       border: 1px solid #bababa;
     }
   </style>
  </head>

  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="._main_fem023.html" title="Bibliography"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="._main_fem021.html" title="Systems of differential equations"
             accesskey="P">previous</a> |</li>
        <li><a href="index.html">Introduction to finite element methods</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="exercises-2">
<h1>Exercises  (2)<a class="headerlink" href="#exercises-2" title="Permalink to this headline">¶</a></h1>
<div class="section" id="exercise-23-refactor-functions-into-a-more-general-class">
<span id="fem-deq-exer-bvp1d-class"></span><h2>Exercise 23: Refactor functions into a more general class<a class="headerlink" href="#exercise-23-refactor-functions-into-a-more-general-class" title="Permalink to this headline">¶</a></h2>
<p>The section <a class="reference internal" href="._main_fem012.html#fem-deq-1d-models-simple"><em>Simple model problems</em></a> displays three functions
for computing the analytical solution of some simple
model problems. There is quite some repetitive code, suggesting
that the functions can benefit from being refactored into a
class where the user can define the <span class="math">\(f(x)\)</span>, <span class="math">\(a(x)\)</span>, and the boundary
conditions in particular methods in subclasses. Demonstrate how
the new class can be used to solve the three particular
problems in the section <a class="reference internal" href="._main_fem012.html#fem-deq-1d-models-simple"><em>Simple model problems</em></a>.</p>
<p>In the method that computes the solution, check that the solution
found fulfills the differential equation and the boundary conditions.
Filename: <tt class="docutils literal"><span class="pre">uxx_f_sympy_class.py</span></tt>.</p>
</div>
<div class="section" id="exercise-24-compute-the-deflection-of-a-cable-with-sine-functions">
<span id="fem-deq-exer-tension-cable"></span><h2>Exercise 24: Compute the deflection of a cable with sine functions<a class="headerlink" href="#exercise-24-compute-the-deflection-of-a-cable-with-sine-functions" title="Permalink to this headline">¶</a></h2>
<p>A hanging cable of length <span class="math">\(L\)</span>
with significant tension <span class="math">\(T\)</span> has a downward deflection <span class="math">\(w(x)\)</span>
governed by</p>
<p>Solve</p>
<div class="math">
\[T w''(x) = \ell(x),\]</div>
<p>when <span class="math">\(\ell(x)\)</span> the vertical load per unit length.
The cable is fixed at <span class="math">\(x=0\)</span> and <span class="math">\(x=L\)</span> so the boundary conditions become
<span class="math">\(w(0)=w(L)=0\)</span>.</p>
<p>If we assume a constant load <span class="math">\(\ell(x)=\hbox{const}\)</span>,
the solution is expected to be symmetric around <span class="math">\(x=L/2\)</span>. For a function
<span class="math">\(w(x)\)</span> that is symmetric around some point <span class="math">\(x_0\)</span>, it means that
<span class="math">\(w(x_0-h) = w(x_0+h)\)</span>, and then <span class="math">\(w'(x_0)=\lim_{h\rightarrow 0}(w(x_0+h)-
w(x_0-h))/(2h)=0\)</span>. We can therefore halve the domain and
seek <span class="math">\(w(x)\)</span> in <span class="math">\([0,L/2]\)</span> with boundary conditions <span class="math">\(w(0)=0\)</span> and
<span class="math">\(w'(L/2)=0\)</span>.</p>
<p>The problem can be scaled by introducing a dimensionless coordinate
(also called <span class="math">\(x\)</span>) in <span class="math">\([0,1]\)</span> and a dimensionless vertical
deflection <span class="math">\(u(x)\)</span>.
The differential equation problem for <span class="math">\(u(x)\)</span> becomes</p>
<div class="math">
\[u'' = 1,\quad x\in (0,1),\quad u(0)=0,\ u'(1)=0{\thinspace .}\]</div>
<p>A possible function space is spanned by <span class="math">\({\psi}_i=\sin ((i+1)\pi x/2)\)</span>,
<span class="math">\(i=0,\ldots,N\)</span>.
Use a Galerkin and a least squares method to find the coefficients
<span class="math">\(c_j\)</span> in <span class="math">\(u(x)=\sum_j c_j{\psi}_j\)</span>. Find how fast the coefficients
decrease in magnitude by looking at <span class="math">\(c_j/c_{j-1}\)</span>.
Find the error in the maximum deflection at <span class="math">\(x=1\)</span> when only one
basis function is used (<span class="math">\(N=0\)</span>).</p>
<p>What happens if we choose basis functions
<span class="math">\({\psi}_i=\sin ((i+1)\pi x)\)</span>? These basis functions are appropriate
if we do not utilize symmetry and solve the original problem on <span class="math">\([0,L]\)</span>.
A scaled version of this problem reads</p>
<div class="math">
\[u''=1,\quad x\in(0,1),\quad u(0)=u(1)=0{\thinspace .}\]</div>
<p>Carry out the computations with <span class="math">\(N=0\)</span> and demonstrate that the
maximum deflection <span class="math">\(u(1/2)\)</span> is the same in the problem utilizing
symmetry and the problem covering the whole cable.
Filename: <tt class="docutils literal"><span class="pre">cable_sin.pdf</span></tt>.</p>
</div>
<div class="section" id="exercise-25-check-integration-by-parts">
<span id="fem-deq-exer-intg-parts"></span><h2>Exercise 25: Check integration by parts<a class="headerlink" href="#exercise-25-check-integration-by-parts" title="Permalink to this headline">¶</a></h2>
<p>Consider the Galerkin method for the problem involving <span class="math">\(u\)</span>
in <a class="reference internal" href="#fem-deq-exer-tension-cable"><em>Exercise 24: Compute the deflection of a cable with sine functions</em></a>.
Show that the formulas for <span class="math">\(c_j\)</span> are independent of whether we perform
integration by parts or not.
Filename: <tt class="docutils literal"><span class="pre">cable_integr_by_parts.pdf</span></tt>.</p>
</div>
<div class="section" id="exercise-26-compute-the-deflection-of-a-cable-with-2-p1-elements">
<span id="id1"></span><h2>Exercise 26: Compute the deflection of a cable with 2 P1 elements<a class="headerlink" href="#exercise-26-compute-the-deflection-of-a-cable-with-2-p1-elements" title="Permalink to this headline">¶</a></h2>
<p>Solve the problem for <span class="math">\(u\)</span> in <a class="reference internal" href="#fem-deq-exer-tension-cable"><em>Exercise 24: Compute the deflection of a cable with sine functions</em></a>
using two P1 linear elements.
Filename: <tt class="docutils literal"><span class="pre">cable_2P1.pdf</span></tt>.</p>
</div>
<div class="section" id="exercise-27-compute-the-deflection-of-a-cable-with-1-p2-element">
<span id="id2"></span><h2>Exercise 27: Compute the deflection of a cable with 1 P2 element<a class="headerlink" href="#exercise-27-compute-the-deflection-of-a-cable-with-1-p2-element" title="Permalink to this headline">¶</a></h2>
<p>Solve the problem for <span class="math">\(u\)</span> in <a class="reference internal" href="#fem-deq-exer-tension-cable"><em>Exercise 24: Compute the deflection of a cable with sine functions</em></a>
using one P2 element with quadratic basis functions.
Filename: <tt class="docutils literal"><span class="pre">cable_1P2.pdf</span></tt>.</p>
</div>
<div class="section" id="exercise-28-compute-the-deflection-of-a-cable-with-a-step-load">
<span id="id3"></span><h2>Exercise 28: Compute the deflection of a cable with a step load<a class="headerlink" href="#exercise-28-compute-the-deflection-of-a-cable-with-a-step-load" title="Permalink to this headline">¶</a></h2>
<p>We consider the deflection of a tension cable as described in
<a class="reference internal" href="#fem-deq-exer-tension-cable"><em>Exercise 24: Compute the deflection of a cable with sine functions</em></a>. Now the load is</p>
<div class="math">
\[\begin{split}\ell (x) =\left\lbrace\begin{array}{ll}
\ell_1, &amp; x &lt;L/2,\\
\ell_2, &amp; x \geq L/2
\end{array}\right.\quad x\in [0,L]
{\thinspace .}\end{split}\]</div>
<p>This load is not symmetric
with respect to the midpoint <span class="math">\(x=L/2\)</span> so the solution loses its symmetry
and we must solve the scaled problem</p>
<div class="math">
\[\begin{split}u'' =\left\lbrace\begin{array}{ll}
1, &amp; x &lt;1/2,\\
0, &amp; x \geq 1/2
\end{array}\right.
\quad x\in (0,1),\quad u(0)=0,\ u(1)=0
{\thinspace .}\end{split}\]</div>
<p><strong>a)</strong>
Use <span class="math">\({\psi}_i = \sin((i+1)\pi x)\)</span>, <span class="math">\(i=0,\ldots,N\)</span> and the Galerkin method
without integration by parts. Derive a formula
for <span class="math">\(c_j\)</span> in the solution expansion <span class="math">\(u=\sum_j c_j{\psi}_j\)</span>.
Plot how fast the coefficients <span class="math">\(c_j\)</span> tend to zero (on a log scale).</p>
<p><strong>b)</strong>
Solve the problem with P1 finite elements.
Plot the solution for <span class="math">\(N_e=2,4,8\)</span> elements.</p>
<p>Filename: <tt class="docutils literal"><span class="pre">cable_discont_load.pdf</span></tt>.</p>
</div>
<div class="section" id="exercise-29-show-equivalence-between-linear-systems">
<span id="fem-deq-exer-aub-essbc-equiv"></span><h2>Exercise 29: Show equivalence between linear systems<a class="headerlink" href="#exercise-29-show-equivalence-between-linear-systems" title="Permalink to this headline">¶</a></h2>
<p>Incorporation of Dirichlet conditions at <span class="math">\(x=0\)</span> and <span class="math">\(x=L\)</span>
in a finite element mesh on <span class="math">\(\Omega=[0,L]\)</span> can either be done by
introducing an expansion <span class="math">\(u(x)=U_0{\varphi}_0 + U_{N_n}{\varphi}_{N_n} +
\sum_{j=0}^{N} c_j{\varphi}_{\nu(j)}\)</span>,
with <span class="math">\(N=N_n-2\)</span> and considering <span class="math">\(u\)</span> values at the
inner nodes as unknowns, <em>or</em>
one can assemble the matrix system with <span class="math">\(u(x)=\sum_{j=0}^{N=N_n}
c_j{\varphi}_j\)</span> and afterwards replace the rows corresponding to known
<span class="math">\(c_j\)</span> values by the boundary conditions.
Show that the two approaches are equivalent.</p>
</div>
<div class="section" id="exercise-30-compute-with-a-non-uniform-mesh">
<span id="fem-deq-exer-1d-mesh-nonuniform"></span><h2>Exercise 30: Compute with a non-uniform mesh<a class="headerlink" href="#exercise-30-compute-with-a-non-uniform-mesh" title="Permalink to this headline">¶</a></h2>
<p>Derive the linear system for the problem <span class="math">\(-u''=2\)</span> on <span class="math">\([0,1]\)</span>,
with <span class="math">\(u(0)=0\)</span> and <span class="math">\(u(1)=1\)</span>, using P1 elements and a <em>non-uniform</em>
mesh. The vertices have coordinates <span class="math">\(x_{0}=0 &lt; x_{1} &lt;\cdots &lt; x_{N}=1\)</span>,
and the length of cell number <span class="math">\(e\)</span> is <span class="math">\(h_e = x_{e+1} -x_{e}\)</span>.</p>
<p>It is of interest to compare the discrete equations for the finite element
method in a non-uniform mesh with the corresponding discrete equations
arising from a finite difference method. Go through the
derivation of
the finite difference formula <span class="math">\(u''(x_i) \approx [D_x D_x u]_i\)</span> and
modify it to find a natural discretization of <span class="math">\(u''(x_i)\)</span> on a non-uniform
mesh.
Filename: <tt class="docutils literal"><span class="pre">nonuniform_P1.pdf</span></tt>.</p>
</div>
<div class="section" id="problem-31-solve-a-1d-finite-element-problem-by-hand">
<span id="fem-deq-exer-1d-gen-problem1"></span><h2>Problem 31: Solve a 1D finite element problem by hand<a class="headerlink" href="#problem-31-solve-a-1d-finite-element-problem-by-hand" title="Permalink to this headline">¶</a></h2>
<p>The following scaled 1D problem is a very simple, yet relevant, model
for convective transport in fluids:</p>
<div class="math">
\[u' = \epsilon u'' ,\quad u(0)=0,\ u(1)=1,\ x\in [0,1]
{\thinspace .}\]</div>
<p><strong>a)</strong>
Find the analytical solution to this problem.
(Introduce <span class="math">\(w=u'\)</span>, solve the first-order differential equation for <span class="math">\(w(x)\)</span>,
and integrate once more.)</p>
<p><strong>b)</strong>
Derive the variational form of this problem.</p>
<p><strong>c)</strong>
Introduce a finite element mesh with uniform partitioning.
Use P1 elements and compute the element matrix and vector for
a general element.</p>
<p><strong>d)</strong>
Incorporate the boundary conditions and
assemble the element contributions.</p>
<p><strong>e)</strong>
Identify the resulting linear system as a finite difference discretization
of the differential equation using</p>
<div class="math">
\[[D_{2x}u = \epsilon D_xD_x u]_i {\thinspace .}\]</div>
<p><strong>f)</strong>
Compute the numerical solution and plot it together with the exact solution
for a mesh with 20 elements and
<span class="math">\(\epsilon=10, 1, 0.1, 0.01\)</span>.</p>
<p>Filename: <tt class="docutils literal"><span class="pre">convdiff1D_P1.pdf</span></tt>.</p>
</div>
<div class="section" id="exercise-32-compare-finite-elements-and-differences-for-a-radially-symmetric-poisson-equation">
<span id="fem-deq-exer-1d-poisson-polar"></span><h2>Exercise 32: Compare finite elements and differences for a radially symmetric Poisson equation<a class="headerlink" href="#exercise-32-compare-finite-elements-and-differences-for-a-radially-symmetric-poisson-equation" title="Permalink to this headline">¶</a></h2>
<p>We consider the Poisson problem in a disk with radius <span class="math">\(R\)</span> with
Dirichlet conditions at the boundary.
Given that the solution is radially symmetric and hence dependent only on
the radial coordinate (<span class="math">\(r=\sqrt{x^2+y^2}\)</span>), we can reduce the problem
to a 1D Poisson equation</p>
<div class="math" id="equation-fem:deq:exer:1D:Poisson:polar:eq">
<span id="eq-fem-deq-exer-1d-poisson-polar-eq"></span><span class="eqno">(1)</span>\[     -\frac{1}{r}\frac{d}{dr}\left( r\frac{du}{dr}\right) = f(r),\quad r\in (0,R),\
     u'(0)=0,\ u(R)=U_R
     {\thinspace .}\]</div>
<p><strong>a)</strong>
Derive a variational form of <a href="#equation-fem:deq:exer:1D:Poisson:polar:eq">(1)</a>
by integrating over the whole disk, or posed equivalently: use
a weighting function <span class="math">\(2\pi r v(r)\)</span> and integrate <span class="math">\(r\)</span> from <span class="math">\(0\)</span> to <span class="math">\(R\)</span>.</p>
<p><strong>b)</strong>
Use a uniform mesh partition with P1 elements and show what the
resulting set of equations becomes. Integrate the matrix entries
exact by hand, but use a Trapezoidal rule to integrate the <span class="math">\(f\)</span> term.</p>
<p><strong>c)</strong>
Explain that an intuitive
finite difference method applied to <a href="#equation-fem:deq:exer:1D:Poisson:polar:eq">(1)</a>
gives</p>
<div class="math">
\[\frac{1}{r_i}\frac{1}{h^2}\left( r_{i+\frac{1}{2}}(u_{i+1}-u_i) -
r_{i-\frac{1}{2}}(u_{i}-u_{i-1})\right) = f_i,\quad i=rh
{\thinspace .}\]</div>
<p>For <span class="math">\(i=0\)</span> the factor <span class="math">\(1/r_i\)</span> seemingly becomes problematic. One must always
have <span class="math">\(u'(0)=0\)</span>, because of the radial symmetry, which implies
<span class="math">\(u_{-1}=u_1\)</span>, if we allow introduction of a fictitious value <span class="math">\(u_{-1}\)</span>.
Using this <span class="math">\(u_{-1}\)</span> in the difference equation for <span class="math">\(i=0\)</span> gives</p>
<div class="math">
\[\begin{split}&amp;\frac{1}{r_0}\frac{1}{h^2}\left( r_{\frac{1}{2}}(u_{1}-u_0) -
r_{-\frac{1}{2}}(u_{0}-u_{1})\right) = \\
&amp; \qquad
\frac{1}{r_0}\frac{1}{2h^2}\left( (r_0 + r_1)(u_{1}-u_0) -
(r_{-1} + r_0)(u_{0}-u_{1})\right) \approx
2(u_1-u_0),\end{split}\]</div>
<p>if we use <span class="math">\(r_{-1}+r_1\approx 2r_0\)</span>.</p>
<p>Set up the complete set of equations for the finite difference method
and compare to the finite element method in case a Trapezoidal rule
is used to integrate the <span class="math">\(f\)</span> term in the latter method.</p>
<p>Filename: <tt class="docutils literal"><span class="pre">radial_Poisson1D_P1.pdf</span></tt>.</p>
</div>
<div class="section" id="exercise-33-compute-with-variable-coefficients-and-p1-elements-by-hand">
<span id="fem-deq-exer-1d-gen-problem2"></span><h2>Exercise 33: Compute with variable coefficients and P1 elements by hand<a class="headerlink" href="#exercise-33-compute-with-variable-coefficients-and-p1-elements-by-hand" title="Permalink to this headline">¶</a></h2>
<p>Consider the problem</p>
<div class="math" id="equation-fem:deq:1D:model4">
<span id="eq-fem-deq-1d-model4"></span><span class="eqno">(2)</span>\[     -\frac{d}{dx}\left( a(x)\frac{du}{dx}\right) + \gamma u = f(x),
     \quad x\in\Omega=[0,L],\quad u(0)={\alpha},\ u'(L)=\beta{\thinspace .}\]</div>
<p>We choose <span class="math">\(a(x)=1+x^2\)</span>. Then</p>
<div class="math">
\[u(x) = {\alpha} + \beta(1+L^2)\tan^{-1}(x),\]</div>
<p>is an exact solution if <span class="math">\(f(x) = \gamma u\)</span>.</p>
<p>Derive a variational formulation and compute general expressions for the
element matrix and vector in an arbitrary element, using P1 elements
and a uniform partitioning of <span class="math">\([0,L]\)</span>. The right-hand side
integral is challenging and can be computed by a numerical integration
rule. The Trapezoidal rule <a class="reference internal" href="._main_fem008.html#eq-fem-approx-fe-numint1-trapez"><em>(9.1)</em></a>
gives particularly simple expressions.
Filename: <tt class="docutils literal"><span class="pre">atan1D_P1.pdf</span></tt>.</p>
</div>
<div class="section" id="exercise-34-solve-a-2d-poisson-equation-using-polynomials-and-sines">
<span id="fem-deq-exer-2d-torsion-xy-sin"></span><h2>Exercise 34: Solve a 2D Poisson equation using polynomials and sines<a class="headerlink" href="#exercise-34-solve-a-2d-poisson-equation-using-polynomials-and-sines" title="Permalink to this headline">¶</a></h2>
<p>The classical problem of applying a torque to the ends of a rod
can be modeled by a Poisson equation defined in the cross section <span class="math">\(\Omega\)</span>:</p>
<div class="math">
\[-\nabla^2 u = 2,\quad (x,y)\in\Omega,\]</div>
<p>with <span class="math">\(u=0\)</span> on <span class="math">\(\partial\Omega\)</span>. Exactly the same problem arises for
the deflection of a membrane with shape <span class="math">\(\Omega\)</span> under a constant load.</p>
<p>For a circular cross section one can readily
find an analytical solution. For a rectangular cross section the analytical
approach ends up with a sine series. The idea in this exercise is to
use a single basis function to obtain an approximate answer.</p>
<p>We assume for simplicity that the cross section is the unit square:
<span class="math">\(\Omega = [0,1]\times [0,1]\)</span>.</p>
<p><strong>a)</strong>
We consider the basis
<span class="math">\({\psi}_{p,q}(x,y) = \sin((p+1)\pi x)\sin (q\pi y)\)</span>, <span class="math">\(p,q=0,\ldots,n\)</span>.
These basis functions fulfill the Dirichlet condition.
Use a Galerkin method and <span class="math">\(n=0\)</span>.</p>
<p><strong>b)</strong>
The basis function involving sine functions are orthogonal.
Use this property in the Galerkin method
to derive the coefficients <span class="math">\(c_{p,q}\)</span> in a
formula <span class="math">\(u=\sum_p\sum_q c_{p,q}{\psi}_{p,q}(x,y)\)</span>.</p>
<p><strong>c)</strong>
Another possible basis is
<span class="math">\({\psi}_i(x,y) = (x(1-x)y(1-y))^{i+1}\)</span>, <span class="math">\(i=0,\ldots,N\)</span>.
Use the Galerkin method to compute the solution for <span class="math">\(N=0\)</span>.
Which choice of a single basis function is best,
<span class="math">\(u\sim x(1-x)y(1-y)\)</span> or <span class="math">\(u\sim \sin(\pi x)\sin(\pi y)\)</span>?
In order to answer the question,
it is necessary to search the web or the literature for an accurate
estimate of the maximum <span class="math">\(u\)</span> value at <span class="math">\(x=y=1/2\)</span>.</p>
<p>Filename: <tt class="docutils literal"><span class="pre">torsion_sin_xy.pdf</span></tt>.</p>
</div>
<div class="section" id="exercise-35-analyze-a-crank-nicolson-scheme-for-the-diffusion-equation">
<span id="fem-deq-exer-diffu-analysis-cn"></span><h2>Exercise 35: Analyze a Crank-Nicolson scheme for the diffusion equation<a class="headerlink" href="#exercise-35-analyze-a-crank-nicolson-scheme-for-the-diffusion-equation" title="Permalink to this headline">¶</a></h2>
<p>Perform the analysis in the section <a class="reference internal" href="._main_fem020.html#fem-deq-diffu-anal"><em>Analysis of the discrete equations</em></a> for a 1D
diffusion equation <span class="math">\(u_t = {\alpha} u_{xx}\)</span> discretized by the
Crank-Nicolson scheme in time:</p>
<div class="math">
\[\frac{u^{n+1}- u^n}{\Delta t} = {\alpha} \frac{1}{2}\left(
\frac{\partial u^{n+1}}{\partial x^2}
\frac{\partial u^{n}}{\partial x^2}\right),\]</div>
<p>or written compactly with finite difference operators,</p>
<div class="math">
\[[D_t u = {\alpha} D_xD_x \overline{u}^t]^{n+\frac{1}{2}}{\thinspace .}\]</div>
<p>(From a strict mathematical point of view, the <span class="math">\(u^n\)</span>
and <span class="math">\(u^{n+1}\)</span> in these
equations should be replaced by <span class="math">\({u_{\small\mbox{e}}}^n\)</span> and <span class="math">\({u_{\small\mbox{e}}}^{n+1}\)</span> to
indicate that the unknown is the exact solution of the PDE
discretized in time, but not yet in space, see
the section <a class="reference internal" href="._main_fem020.html#fem-deq-diffu-fe"><em>Discretization in time by a Forward Euler scheme</em></a>.) Make plots similar to those
in the section <a class="reference internal" href="._main_fem020.html#fem-deq-diffu-anal"><em>Analysis of the discrete equations</em></a>.
Filename: <tt class="docutils literal"><span class="pre">fe_diffusion.pdf</span></tt>.</p>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
            <center>
            <p class="logo"><a href="http://cbc.simula.no/" title="Go to Center for Biomedical Computing">
              <img class="logo" src="_static/cbc_logo.png" alt="Logo"/>
            </a></p>
            </center>
  <h3><a href="index.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Exercises  (2)</a><ul>
<li><a class="reference internal" href="#exercise-23-refactor-functions-into-a-more-general-class">Exercise 23: Refactor functions into a more general class</a></li>
<li><a class="reference internal" href="#exercise-24-compute-the-deflection-of-a-cable-with-sine-functions">Exercise 24: Compute the deflection of a cable with sine functions</a></li>
<li><a class="reference internal" href="#exercise-25-check-integration-by-parts">Exercise 25: Check integration by parts</a></li>
<li><a class="reference internal" href="#exercise-26-compute-the-deflection-of-a-cable-with-2-p1-elements">Exercise 26: Compute the deflection of a cable with 2 P1 elements</a></li>
<li><a class="reference internal" href="#exercise-27-compute-the-deflection-of-a-cable-with-1-p2-element">Exercise 27: Compute the deflection of a cable with 1 P2 element</a></li>
<li><a class="reference internal" href="#exercise-28-compute-the-deflection-of-a-cable-with-a-step-load">Exercise 28: Compute the deflection of a cable with a step load</a></li>
<li><a class="reference internal" href="#exercise-29-show-equivalence-between-linear-systems">Exercise 29: Show equivalence between linear systems</a></li>
<li><a class="reference internal" href="#exercise-30-compute-with-a-non-uniform-mesh">Exercise 30: Compute with a non-uniform mesh</a></li>
<li><a class="reference internal" href="#problem-31-solve-a-1d-finite-element-problem-by-hand">Problem 31: Solve a 1D finite element problem by hand</a></li>
<li><a class="reference internal" href="#exercise-32-compare-finite-elements-and-differences-for-a-radially-symmetric-poisson-equation">Exercise 32: Compare finite elements and differences for a radially symmetric Poisson equation</a></li>
<li><a class="reference internal" href="#exercise-33-compute-with-variable-coefficients-and-p1-elements-by-hand">Exercise 33: Compute with variable coefficients and P1 elements by hand</a></li>
<li><a class="reference internal" href="#exercise-34-solve-a-2d-poisson-equation-using-polynomials-and-sines">Exercise 34: Solve a 2D Poisson equation using polynomials and sines</a></li>
<li><a class="reference internal" href="#exercise-35-analyze-a-crank-nicolson-scheme-for-the-diffusion-equation">Exercise 35: Analyze a Crank-Nicolson scheme for the diffusion equation</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="._main_fem021.html"
                        title="previous chapter">Systems of differential equations</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="._main_fem023.html"
                        title="next chapter">Bibliography</a></p>
  <h3>This Page</h3>
  <ul class="this-page-menu">
    <li><a href="_sources/._main_fem022.txt"
           rel="nofollow">Show Source</a></li>
  </ul>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="._main_fem023.html" title="Bibliography"
             >next</a> |</li>
        <li class="right" >
          <a href="._main_fem021.html" title="Systems of differential equations"
             >previous</a> |</li>
        <li><a href="index.html">Introduction to finite element methods</a> &raquo;</li> 
      </ul>
    </div>
<div class="wrapper">
  <div class="footer">
  <a href="http://cbc.simula.no"><img src="_static/cbc_banner.png" width="100%"><a>
  </div>
</div>

  </body>
</html>